"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  defaultOptions: () => defaultOptions,
  engrave: () => engrave,
  readEngrave: () => readEngrave
});
module.exports = __toCommonJS(src_exports);

// src/ngrv.ts
var import_child_process = require("child_process");
var import_fs = __toESM(require("fs"));
var import_path = __toESM(require("path"));
var import_chalk = __toESM(require("chalk"));
var rootDir = process.cwd();
var defaultOptions = {
  directory: ".",
  builtAtFile: "__NGRV_BUILT_AT",
  commitHashFile: "__NGRV_COMMIT_HASH",
  silent: false
};
var engrave = (options = defaultOptions) => {
  const { directory, builtAtFile, commitHashFile, silent } = __spreadValues(__spreadValues({}, defaultOptions), options);
  const envs = {};
  const folderPath = import_path.default.join(rootDir, directory);
  if (!import_fs.default.existsSync(folderPath)) {
    import_fs.default.mkdirSync(folderPath);
  }
  try {
    const builtAt = Date.now().toString().trim();
    const iso = new Date(parseInt(builtAt, 10)).toISOString();
    const fpath = import_path.default.join(folderPath, builtAtFile);
    console.log(import_chalk.default.greenBright(`[ngrv] saved at ${fpath}`));
    console.log(import_chalk.default.greenBright(`[ngrv] ${builtAtFile}: ${builtAt} (${iso})`));
    import_fs.default.writeFileSync(fpath, builtAt, "utf8");
    envs.__NGRV_BUILT_AT = builtAt;
  } catch (err) {
    console.error(err == null ? void 0 : err.message);
  }
  try {
    const commitHash = (0, import_child_process.execSync)("git rev-parse HEAD").toString("utf8").trim();
    const fpath = import_path.default.join(folderPath, commitHashFile);
    console.log(import_chalk.default.greenBright(`[ngrv] saved at ${fpath}`));
    console.log(import_chalk.default.greenBright(`[ngrv] ${commitHashFile}: ${commitHash}`));
    import_fs.default.writeFileSync(fpath, commitHash, "utf8");
    envs.__NGRV_COMMIT_HASH = commitHash;
  } catch (err) {
    console.error(err == null ? void 0 : err.message);
  }
  return envs;
};
var readEngrave = (options = defaultOptions) => {
  const { directory, builtAtFile, commitHashFile, silent } = __spreadValues(__spreadValues({}, defaultOptions), options);
  const envs = {};
  const folderPath = import_path.default.join(rootDir, directory);
  try {
    const fpath = import_path.default.join(folderPath, builtAtFile);
    const builtAt = import_fs.default.readFileSync(fpath, "utf8").trim();
    process.env[builtAtFile] = builtAt;
    envs.__NGRV_BUILT_AT = builtAt;
    if (!silent) {
      const iso = new Date(parseInt(builtAt, 10)).toISOString();
      console.log(import_chalk.default.greenBright(`[ngrv] read from ${fpath}`));
      console.log(import_chalk.default.greenBright(`[ngrv] ${builtAtFile}: ${builtAt} (${iso})`));
    }
  } catch (err) {
    console.error(err == null ? void 0 : err.message);
  }
  try {
    const fpath = import_path.default.join(folderPath, commitHashFile);
    const commitHash = import_fs.default.readFileSync(fpath, "utf8").trim();
    process.env[commitHashFile] = commitHash;
    envs.__NGRV_COMMIT_HASH = commitHash;
    if (!silent) {
      console.log(import_chalk.default.greenBright(`[ngrv] read from ${fpath}`));
      console.log(import_chalk.default.greenBright(`[ngrv] ${commitHashFile}: ${commitHash}`));
    }
  } catch (err) {
    console.error(err == null ? void 0 : err.message);
  }
  return envs;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  defaultOptions,
  engrave,
  readEngrave
});
//# sourceMappingURL=index.js.map